﻿Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms
Imports Angelmarken.dtsAngelmarken

Public Class frmAngelmarken

    Public Sub New()
        InitializeComponent()

        Me.Text = Date.Now.ToString

        If NotifyPropertyChanged.IsInDesignMode Then Return
        ControlStyling.StyleControls(Me)
        Dts.DataFile("..\..\DataStuff\AngelmarkenData.xml").Register(Me, handleFormClosing:=True).Fill
    End Sub

    Private Sub frmAngelmarken_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'verstecken der Reiter vom Main TabControl
        With TCMain
            .SuspendLayout()
            .SizeMode = TabSizeMode.Fixed
            .ItemSize = New Size(0, 1)
            .Appearance = TabAppearance.Buttons
            .ResumeLayout()
        End With
    End Sub

    Private Sub frmAngelmarken_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        Save(dtsAngelmarken, Me, False)
    End Sub
    Private Sub frmAngelmarken_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        'Strg + K zum kopieren
        If e.KeyChar = "" Then
            If TCMain.SelectedTab Is TPPersons Then PersonCopy()
            Exit Sub
        End If
        'Escape
        If e.KeyChar = Convert.ToChar(Keys.Escape) Then
            If TCMain.SelectedTab Is TPPersons Then DelPersonSearch()
            Exit Sub
        End If
        'abbrechen, wenn eine Textbox ausgewählt
        If Me.TBPersonSearch.Focused Then Exit Sub
        'Taste Backspace
        If e.KeyChar = Convert.ToChar(Keys.Back) Then 'Backspace - Löschen des letzten Zeichens
            If TCMain.SelectedTab Is TPPersons Then
                If TBPersonSearch.Text.Length > 0 Then TBPersonSearch.Text = TBPersonSearch.Text.Substring(0, TBPersonSearch.Text.Length - 1)
            End If
            Exit Sub
        End If
        'Tasten in TB übergeben
        If TCMain.SelectedTab Is TPPersons Then TBPersonSearch.AppendText(e.KeyChar)
    End Sub
    Private Sub frmAngelmarken_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyData
            Case = Keys.Delete
                'entfernen zum löschen einer Person
                If TCMain.SelectedTab Is TPPersons Then PersonDelete()
        End Select
    End Sub

    Private Sub BTNSettings_Click(sender As Object, e As EventArgs) Handles BTNSettings.Click, BTNPersons.Click, BTNNewSale.Click
        Dim pressedButton = DirectCast(sender, Button)
        Select Case pressedButton.Name
            Case = "BTNNewSale"
                Me.TCMain.SelectedTab = TPSale
            Case = "BTNPersons"
                Me.TCMain.SelectedTab = TPPersons
            Case = "BTNSettings"
                Me.TCMain.SelectedTab = TPSettings
        End Select
    End Sub

    Private Sub BTNHome_Click(sender As Object, e As EventArgs) Handles BTNHome.Click
        Me.TCMain.SelectedTab = TPHome
    End Sub

#Region "Tab Page Personen"
    'neue Person
    Private Sub BTNPersonNew_Click(sender As Object, e As EventArgs) Handles BTNPersonNew.Click
        PersonBindingSource.EditNew(Of frmEditPerson)
    End Sub
    'Person bearbeiten
    Private Sub BTNPersonEdit_Click(sender As Object, e As EventArgs) Handles BTNPersonEdit.Click
        PersonEdit()
    End Sub
    Private Sub PersonEdit()
        PersonBindingSource.EditCurrent(Of frmEditPerson)
    End Sub
    'Person kopieren
    Private Sub BTNPersonCopy_Click(sender As Object, e As EventArgs) Handles BTNPersonCopy.Click
        PersonCopy()
    End Sub
    Private Sub PersonCopy()
        'Daten der aktuell ausgewählten Person auslesen
        If PersonBindingSource.Current Is Nothing Then Exit Sub
        Dim SelectedPerson = DirectCast(DirectCast(PersonBindingSource.Current, DataRowView).Row, PersonRow)
        'Daten der Adresse an bearbeitenForm übergeben
        Dim tpls As New List(Of Tuple(Of DataColumn, Object))
        With dtsAngelmarken.Person
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.NameColumn, SelectedPerson.Name))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.StrasseColumn, SelectedPerson.Strasse))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.HausnummerColumn, SelectedPerson.Hausnummer))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.PLZColumn, SelectedPerson.PLZ))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.OrtColumn, SelectedPerson.Ort))
            PersonBindingSource.EditNew(Of frmEditPerson)(tpls)
        End With
    End Sub
    'Person löschen
    Private Sub BTNPersonDelete_Click(sender As Object, e As EventArgs) Handles BTNPersonDelete.Click
        PersonDelete()
    End Sub
    Private Sub PersonDelete()
        If PersonBindingSource.Current Is Nothing Then Exit Sub
        'ausgewählten Person auslesen
        Dim Person = DirectCast(DirectCast(PersonBindingSource.Current, DataRowView).Row, PersonRow)
        If MessageBox.Show(Person.Vorname & " " & Person.Name & " und all seine Einkäufe werden gelöscht. " & Environment.NewLine &
                           "Sind sie sicher?", "Person löschen", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            PersonBindingSource.RemoveCurrent()
        End If
    End Sub
    'Suchenfeld löschen
    Private Sub BTNPersonDelSearch_Click(sender As Object, e As EventArgs) Handles BTNPersonDelSearch.Click
        DelPersonSearch()
    End Sub
    Private Sub DelPersonSearch()
        TBPersonSearch.Text = ""
    End Sub
    'Filter für Personbindingsource (Suchen Textbox)
    Private Sub TBPersonSearch_TextChanged(sender As Object, e As EventArgs) Handles TBPersonSearch.TextChanged
        PersonBindingSource.FilterX($"Name LIKE '*{TBPersonSearch.Text}*' OR Vorname LIKE '*{TBPersonSearch.Text}*'")
    End Sub

#End Region

End Class